package mail

import (
	maildb "server/datacenter/mail_db"
	"server/msg"

	"github.com/name5566/leaf/gate"
)

func GetMail(args []interface{}) {
	m := args[0].(*msg.ReqMail)
	a := args[1].(gate.Agent)
	FromUserInfo := a.UserData().(*msg.UserInfo)
	var mailList []*msg.MailInfo
	var err error
	if m.MailType == 1 { //系统
		mailList, err = maildb.GetMailsByType(int(m.MailType), "")
	} else if m.MailType == 1 { //个人
		mailList, err = maildb.GetMailsByType(int(m.MailType), FromUserInfo.UserId)
	}

	if err != nil {
		a.WriteMsg(&msg.ResMail{
			Success: false,
			ErrMsg: &msg.MsgError{
				ErrorCode: 101,
				ErrorMsg:  err.Error(),
			},
		})
	} else {
		a.WriteMsg(&msg.ResMail{
			Success: true,
			List:    mailList,
		})
	}
}

func OptMail(args []interface{}) {
	m := args[0].(*msg.OptMail)
	a := args[1].(gate.Agent)
	FromUserInfo := a.UserData().(*msg.UserInfo)
	if m.Opt == msg.OptMailType_CHECK { //查看
		maildb.UpdateCheckStatus(int(m.MailId), 1)
	} else if m.Opt == msg.OptMailType_DELETE { //删除
		maildb.DeleteMail(int(m.MailId), FromUserInfo.UserId)
	} else if m.Opt == msg.OptMailType_RECEIVE { //领取
		maildb.UpdateReceiveStatus(int(m.MailId), 1)
	}
}
